/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.cosmodas.EntCosmos;

import java.io.Serializable;
import java.math.BigDecimal;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * @author obper
 */
@Entity
@Table(name = "detalle_compra_temporal")
@XmlRootElement
@NamedQueries({
        @NamedQuery(name = "DetalleCompraTemporal.findAll", query = "SELECT d FROM DetalleCompraTemporal d"),
        @NamedQuery(name = "DetalleCompraTemporal.findByCompraCodigo", query = "SELECT d FROM DetalleCompraTemporal d WHERE d.detalleCompraTemporalPK.compraCodigo = :compraCodigo"),
        @NamedQuery(name = "DetalleCompraTemporal.findByProductoCodigo", query = "SELECT d FROM DetalleCompraTemporal d WHERE d.detalleCompraTemporalPK.productoCodigo = :productoCodigo"),
        @NamedQuery(name = "DetalleCompraTemporal.findByCantidad", query = "SELECT d FROM DetalleCompraTemporal d WHERE d.cantidad = :cantidad"),
        @NamedQuery(name = "DetalleCompraTemporal.findByCompraPrecio", query = "SELECT d FROM DetalleCompraTemporal d WHERE d.compraPrecio = :compraPrecio"),
        @NamedQuery(name = "DetalleCompraTemporal.findByTipo", query = "SELECT d FROM DetalleCompraTemporal d WHERE d.detalleCompraTemporalPK.tipo = :tipo"),
        @NamedQuery(name = "DetalleCompraTemporal.findByDetalleEnvio", query = "SELECT d FROM DetalleCompraTemporal d WHERE d.detalleEnvio = :detalleEnvio")})
public class DetalleCompraTemporal implements Serializable {
    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected DetalleCompraTemporalPK detalleCompraTemporalPK;
    @Basic(optional = false)
    @NotNull
    @Column(name = "cantidad")
    private int cantidad;
    // @Max(value=?)  @Min(value=?)//if you know range of your decimal fields consider using these annotations to enforce field validation
    @Basic(optional = false)
    @NotNull
    @Column(name = "compra_precio")
    private BigDecimal compraPrecio;
    @Basic(optional = false)
    @NotNull
    @Column(name = "detalle_envio")
    private Character detalleEnvio;

    public DetalleCompraTemporal() {
    }

    public DetalleCompraTemporal(DetalleCompraTemporalPK detalleCompraTemporalPK) {
        this.detalleCompraTemporalPK = detalleCompraTemporalPK;
    }

    public DetalleCompraTemporal(DetalleCompraTemporalPK detalleCompraTemporalPK, int cantidad, BigDecimal compraPrecio, Character detalleEnvio) {
        this.detalleCompraTemporalPK = detalleCompraTemporalPK;
        this.cantidad = cantidad;
        this.compraPrecio = compraPrecio;
        this.detalleEnvio = detalleEnvio;
    }

    public DetalleCompraTemporal(String compraCodigo, String productoCodigo, String tipo) {
        this.detalleCompraTemporalPK = new DetalleCompraTemporalPK(compraCodigo, productoCodigo, tipo);
    }

    public DetalleCompraTemporalPK getDetalleCompraTemporalPK() {
        return detalleCompraTemporalPK;
    }

    public void setDetalleCompraTemporalPK(DetalleCompraTemporalPK detalleCompraTemporalPK) {
        this.detalleCompraTemporalPK = detalleCompraTemporalPK;
    }

    public int getCantidad() {
        return cantidad;
    }

    public void setCantidad(int cantidad) {
        this.cantidad = cantidad;
    }

    public BigDecimal getCompraPrecio() {
        return compraPrecio;
    }

    public void setCompraPrecio(BigDecimal compraPrecio) {
        this.compraPrecio = compraPrecio;
    }

    public Character getDetalleEnvio() {
        return detalleEnvio;
    }

    public void setDetalleEnvio(Character detalleEnvio) {
        this.detalleEnvio = detalleEnvio;
    }

//    @Override
//    public int hashCode() {
//        int hash = 0;
//        hash += (detalleCompraTemporalPK != null ? detalleCompraTemporalPK.hashCode() : 0);
//        return hash;
//    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof DetalleCompraTemporal)) {
            return false;
        }
        DetalleCompraTemporal other = (DetalleCompraTemporal) object;
        if ((this.detalleCompraTemporalPK == null && other.detalleCompraTemporalPK != null) || (this.detalleCompraTemporalPK != null && !this.detalleCompraTemporalPK.equals(other.detalleCompraTemporalPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.cosmodas.dbcon.DetalleCompraTemporal[ detalleCompraTemporalPK=" + detalleCompraTemporalPK + " ]";
    }

}
